dk = do ->
  mod = {}
  plugins = {}
  loadedPlugins = {}
  pluginExtensions = {}

  mod.plugin = (namespace, deps, func) ->
    if typeof deps == "function"
      func = deps
      deps = []
    plugins[namespace] = {dependencies: deps, init: func}

  mod.extendPlugin = (namespace, deps, func) ->
    if _.isFunction deps
      func = deps
      deps = []
    pluginExtensions[namespace] ?= []
    pluginExtensions[namespace].push {dependencies: deps, init: func}

  mod.loadPlugin = (namespace) ->
    return if loadedPlugins[namespace]
    loadedPlugins[namespace] = true

    meta = plugins[namespace]
    return unless meta

    # FIXME: Circular dependencies need to be handled
    for dep in meta.dependencies
      mod.loadPlugin dep

    parts = namespace.split '.'
    lastPart = parts.pop()
    currentNs = mod
    currentNsName = null
    for part in parts
      if currentNsName
        currentNsName += ".#{part}"
      else
        currentNsName = part
      dk.loadPlugin currentNsName

      currentNs[part] ?= {}
      currentNs = currentNs[part]
    
    plugin = meta.init()

    if pluginExtensions[namespace]
      _.each pluginExtensions[namespace], (extMeta) ->
        extMeta.dependencies.forEach (p) -> mod.loadPlugin(p)
        plugin = extMeta.init(plugin)

    currentNs[lastPart] = plugin

  mod.loadPlugins = ->
    for namespace, func of plugins
      mod.loadPlugin namespace

  $ ->
    mod.loadPlugins()

  return mod
